package com.myeclipseide.example.rest;

import java.util.List;

import javax.persistence.EntityManager;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Response;

import com.myeclipseide.example.jpa.Customer;
import com.myeclipseide.example.jpa.CustomerDAO;
import com.myeclipseide.example.jpa.EntityManagerHelper;

/**
 * @author MyEclipse Web Service Tools
 */
//@Stateless
@javax.inject.Singleton
@Path("Customer")
public class CustomerFacadeREST extends AbstractFacade<Customer> {

	private EntityManager em;
	private CustomerDAO dao = new CustomerDAO();
	private int customerId = 500;

	public CustomerFacadeREST() {
		super(Customer.class);
	}

	@POST
	@Path("add")
	//@Override
	@Consumes("application/json")
	public Response create(Customer customer) {
		List<Customer> existing = dao.findByCustomername(customer.getCustomername());
		if (!existing.isEmpty()) {
			return Response.status(409).entity("Customer with this name already exists").build();
		}		
		EntityManagerHelper.beginTransaction();
		try {
			customer.setCustomernumber(customerId++);
			dao.save(customer);
		} catch (RuntimeException re) {
			EntityManagerHelper.rollback();
			return Response.serverError().build();			
		}
		EntityManagerHelper.commit();
		return Response.ok().build();
	}

	@PUT
	@Override
	@Consumes({ "application/xml", "application/json" })
	public Response edit(Customer entity) {
		return super.edit(entity);
	}

	@DELETE
	@Path("remove/{id}")
	public Response remove(@PathParam("id") Integer id) {
		return super.remove(super.find(id));
	}

	@Produces({ "application/xml", "application/json" })
	@GET
	@Path("{id}")
	public Customer find(@PathParam("id") Integer id) {
		return super.find(id);
	}

	@GET
	@Override
	@Produces({ "application/xml", "application/json" })
	public List<Customer> findAll() {
		return super.findAll();
	}

	@GET
	@Path("{from}/{to}")
	@Produces({ "application/xml", "application/json" })
	public List<Customer> findRange(@PathParam("from") Integer from,
			@PathParam("to") Integer to) {
		return super.findRange(new int[] { from, to });
	}

	@GET
	@Path("count")
	@Produces("text/plain")
	public String countREST() {
		return String.valueOf(super.count());
	}

	@Override
	protected EntityManager getEntityManager() {
		em = EntityManagerHelper.getEntityManager();
		return em;
	}
}
	